/**
 * Hyperledger Cactus Plugin - Connector Xdai
 * Can perform basic tasks on a Xdai ledger
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import type { RequestArgs } from './base';
import { BaseAPI } from './base';
/**
 *
 * @export
 * @interface ConsistencyStrategy
 */
export interface ConsistencyStrategy {
    /**
     *
     * @type {ReceiptType}
     * @memberof ConsistencyStrategy
     */
    'receiptType': ReceiptType;
    /**
     * The amount of milliseconds to wait for the receipt to arrive to the connector. Defaults to 0 which means to wait for an unlimited amount of time. Note that this wait may be interrupted still by other parts of the infrastructure such as load balancers cutting of HTTP requests after some time even if they are the type that is supposed to be kept alive. The question of re-entrance is a broader topic not in scope to discuss here, but it is important to mention it.
     * @type {number}
     * @memberof ConsistencyStrategy
     */
    'timeoutMs'?: number;
    /**
     * The number of blocks to wait to be confirmed in addition to the block containing the transaction in question. Note that if the receipt type is set to only wait for node transaction pool ACK and this parameter is set to anything, but zero then the API will not accept the request due to conflicting parameters.
     * @type {number}
     * @memberof ConsistencyStrategy
     */
    'blockConfirmations': number;
    /**
     * The amount of time (in milliseconds) connector will wait before making another confiramtion request to the network in case of previous confiramtion request fails
     * @type {number}
     * @memberof ConsistencyStrategy
     */
    'pollIntervalMs'?: number;
}
/**
 *
 * @export
 * @interface ContractJSON
 */
export interface ContractJSON {
    [key: string]: any;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'contractName': string;
    /**
     * See https://ethereum.stackexchange.com/a/47556 regarding the maximum length of the bytecode
     * @type {string}
     * @memberof ContractJSON
     */
    'bytecode': string;
    /**
     * The application binary interface of the solidity contract, optional parameter
     * @type {Array<any>}
     * @memberof ContractJSON
     */
    'abi': Array<any>;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'metadata'?: string;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'deployedBytecode'?: string;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'sourceMap'?: string;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'deployedSourceMap'?: string;
    /**
     *
     * @type {string}
     * @memberof ContractJSON
     */
    'sourcePath'?: string;
    /**
     *
     * @type {object}
     * @memberof ContractJSON
     */
    'compiler'?: object;
    /**
     *
     * @type {object}
     * @memberof ContractJSON
     */
    'networks'?: object;
    /**
     *
     * @type {object}
     * @memberof ContractJSON
     */
    'ast'?: object;
    /**
     *
     * @type {object}
     * @memberof ContractJSON
     */
    'functionHashes'?: object;
    /**
     *
     * @type {object}
     * @memberof ContractJSON
     */
    'gasEstimates'?: object;
}
/**
 *
 * @export
 * @interface DeployContractJsonObjectV1Request
 */
export interface DeployContractJsonObjectV1Request {
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof DeployContractJsonObjectV1Request
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {number}
     * @memberof DeployContractJsonObjectV1Request
     */
    'gas'?: number;
    /**
     *
     * @type {string}
     * @memberof DeployContractJsonObjectV1Request
     */
    'gasPrice'?: string;
    /**
     * The amount of milliseconds to wait for a transaction receipt with theaddress of the contract(which indicates successful deployment) beforegiving up and crashing.
     * @type {number}
     * @memberof DeployContractJsonObjectV1Request
     */
    'timeoutMs'?: number;
    /**
     *
     * @type {ContractJSON}
     * @memberof DeployContractJsonObjectV1Request
     */
    'contractJSON': ContractJSON;
    /**
     * The list of arguments to pass in to the constructor of the contract being deployed.
     * @type {Array<any>}
     * @memberof DeployContractJsonObjectV1Request
     */
    'constructorArgs'?: Array<any>;
}
/**
 *
 * @export
 * @interface DeployContractV1Request
 */
export interface DeployContractV1Request {
    /**
     * The contract name for retrieve the contracts json on the keychain.
     * @type {string}
     * @memberof DeployContractV1Request
     */
    'contractName': string;
    /**
     *
     * @type {Array<any>}
     * @memberof DeployContractV1Request
     */
    'constructorArgs'?: Array<any>;
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof DeployContractV1Request
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     * The keychainId for retrieve the contracts json.
     * @type {string}
     * @memberof DeployContractV1Request
     */
    'keychainId': string;
    /**
     *
     * @type {number}
     * @memberof DeployContractV1Request
     */
    'gas'?: number;
    /**
     *
     * @type {string}
     * @memberof DeployContractV1Request
     */
    'gasPrice'?: string;
    /**
     * The amount of milliseconds to wait for a transaction receipt with theaddress of the contract(which indicates successful deployment) beforegiving up and crashing.
     * @type {number}
     * @memberof DeployContractV1Request
     */
    'timeoutMs'?: number;
}
/**
 *
 * @export
 * @interface DeployContractV1Response
 */
export interface DeployContractV1Response {
    /**
     *
     * @type {Web3TransactionReceipt}
     * @memberof DeployContractV1Response
     */
    'transactionReceipt': Web3TransactionReceipt;
}
/**
 *
 * @export
 * @interface DeployRequestBaseV1
 */
export interface DeployRequestBaseV1 {
    /**
     *
     * @type {ContractJSON}
     * @memberof DeployRequestBaseV1
     */
    'contractJSON': ContractJSON;
    /**
     *
     * @type {Array<any>}
     * @memberof DeployRequestBaseV1
     */
    'constructorArgs'?: Array<any>;
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof DeployRequestBaseV1
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof DeployRequestBaseV1
     */
    'gas'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof DeployRequestBaseV1
     */
    'gasPrice'?: XdaiTransactionConfigFrom;
    /**
     * The amount of milliseconds to wait for a transaction receipt with theaddress of the contract(which indicates successful deployment) beforegiving up and crashing.
     * @type {number}
     * @memberof DeployRequestBaseV1
     */
    'timeoutMs'?: number;
}
/**
 *
 * @export
 * @enum {string}
 */
export declare const EthContractInvocationType: {
    readonly Send: "SEND";
    readonly Call: "CALL";
};
export type EthContractInvocationType = typeof EthContractInvocationType[keyof typeof EthContractInvocationType];
/**
 *
 * @export
 * @interface InvokeContractJsonObjectV1Request
 */
export interface InvokeContractJsonObjectV1Request {
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {EthContractInvocationType}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'invocationType': EthContractInvocationType;
    /**
     * The name of the contract method to invoke.
     * @type {string}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'methodName': string;
    /**
     * The list of arguments to pass in to the contract method being invoked.
     * @type {Array<any>}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'params': Array<any>;
    /**
     * Address of the solidity contract
     * @type {string}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'contractAddress': string;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'value'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'gas'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'gasPrice'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {number}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'nonce'?: number;
    /**
     * The amount of milliseconds to wait for a transaction receipt beforegiving up and crashing. Only has any effect if the invocation type is SEND
     * @type {number}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'timeoutMs'?: number;
    /**
     *
     * @type {ContractJSON}
     * @memberof InvokeContractJsonObjectV1Request
     */
    'contractJSON': ContractJSON;
}
/**
 *
 * @export
 * @interface InvokeContractV1Request
 */
export interface InvokeContractV1Request {
    /**
     * The contract name to find it in the keychain plugin
     * @type {string}
     * @memberof InvokeContractV1Request
     */
    'contractName': string;
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof InvokeContractV1Request
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {EthContractInvocationType}
     * @memberof InvokeContractV1Request
     */
    'invocationType': EthContractInvocationType;
    /**
     * The name of the contract method to invoke.
     * @type {string}
     * @memberof InvokeContractV1Request
     */
    'methodName': string;
    /**
     * The list of arguments to pass in to the contract method being invoked.
     * @type {Array<any>}
     * @memberof InvokeContractV1Request
     */
    'params': Array<any>;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractV1Request
     */
    'value'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractV1Request
     */
    'gas'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeContractV1Request
     */
    'gasPrice'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {number}
     * @memberof InvokeContractV1Request
     */
    'nonce'?: number;
    /**
     * The amount of milliseconds to wait for a transaction receipt beforegiving up and crashing. Only has any effect if the invocation type is SEND
     * @type {number}
     * @memberof InvokeContractV1Request
     */
    'timeoutMs'?: number;
    /**
     * The keychainId for retrieve the contracts json.
     * @type {string}
     * @memberof InvokeContractV1Request
     */
    'keychainId': string;
}
/**
 *
 * @export
 * @interface InvokeContractV1Response
 */
export interface InvokeContractV1Response {
    /**
     *
     * @type {Web3TransactionReceipt}
     * @memberof InvokeContractV1Response
     */
    'transactionReceipt'?: Web3TransactionReceipt;
    /**
     *
     * @type {any}
     * @memberof InvokeContractV1Response
     */
    'callOutput'?: any;
    /**
     *
     * @type {boolean}
     * @memberof InvokeContractV1Response
     */
    'success': boolean;
}
/**
 *
 * @export
 * @interface InvokeRequestBaseV1
 */
export interface InvokeRequestBaseV1 {
    /**
     * Address of the solidity contract
     * @type {string}
     * @memberof InvokeRequestBaseV1
     */
    'contractAddress': string;
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof InvokeRequestBaseV1
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {EthContractInvocationType}
     * @memberof InvokeRequestBaseV1
     */
    'invocationType': EthContractInvocationType;
    /**
     * The name of the contract method to invoke.
     * @type {string}
     * @memberof InvokeRequestBaseV1
     */
    'methodName': string;
    /**
     * The list of arguments to pass in to the contract method being invoked.
     * @type {Array<any>}
     * @memberof InvokeRequestBaseV1
     */
    'params': Array<any>;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeRequestBaseV1
     */
    'value'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeRequestBaseV1
     */
    'gas'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof InvokeRequestBaseV1
     */
    'gasPrice'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {number}
     * @memberof InvokeRequestBaseV1
     */
    'nonce'?: number;
    /**
     * The amount of milliseconds to wait for a transaction receipt beforegiving up and crashing. Only has any effect if the invocation type is SEND
     * @type {number}
     * @memberof InvokeRequestBaseV1
     */
    'timeoutMs'?: number;
    /**
     *
     * @type {ContractJSON}
     * @memberof InvokeRequestBaseV1
     */
    'contractJSON': ContractJSON;
}
/**
 * Enumerates the possible types of receipts that can be waited for by someone or something that has requested the execution of a transaction on a ledger.
 * @export
 * @enum {string}
 */
export declare const ReceiptType: {
    readonly NodeTxPoolAck: "NODE_TX_POOL_ACK";
    readonly LedgerBlockAck: "LEDGER_BLOCK_ACK";
};
export type ReceiptType = typeof ReceiptType[keyof typeof ReceiptType];
/**
 *
 * @export
 * @interface RunTransactionV1Request
 */
export interface RunTransactionV1Request {
    /**
     *
     * @type {Web3SigningCredential}
     * @memberof RunTransactionV1Request
     */
    'web3SigningCredential': Web3SigningCredential;
    /**
     *
     * @type {XdaiTransactionConfig}
     * @memberof RunTransactionV1Request
     */
    'transactionConfig': XdaiTransactionConfig;
    /**
     *
     * @type {ConsistencyStrategy}
     * @memberof RunTransactionV1Request
     */
    'consistencyStrategy': ConsistencyStrategy;
}
/**
 *
 * @export
 * @interface RunTransactionV1Response
 */
export interface RunTransactionV1Response {
    /**
     *
     * @type {Web3TransactionReceipt}
     * @memberof RunTransactionV1Response
     */
    'transactionReceipt': Web3TransactionReceipt;
}
/**
 *
 * @export
 * @interface SolidityContractJsonArtifact
 */
export interface SolidityContractJsonArtifact {
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'contractName': string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'metadata'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'bytecode'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'deployedBytecode'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'sourceMap'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'deployedSourceMap'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifact
     */
    'sourcePath'?: string;
    /**
     *
     * @type {SolidityContractJsonArtifactCompiler}
     * @memberof SolidityContractJsonArtifact
     */
    'compiler'?: SolidityContractJsonArtifactCompiler;
    /**
     *
     * @type {{ [key: string]: any; }}
     * @memberof SolidityContractJsonArtifact
     */
    'functionHashes'?: {
        [key: string]: any;
    };
    /**
     *
     * @type {SolidityContractJsonArtifactGasEstimates}
     * @memberof SolidityContractJsonArtifact
     */
    'gasEstimates'?: SolidityContractJsonArtifactGasEstimates;
}
/**
 *
 * @export
 * @interface SolidityContractJsonArtifactCompiler
 */
export interface SolidityContractJsonArtifactCompiler {
    [key: string]: any;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifactCompiler
     */
    'name'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifactCompiler
     */
    'version'?: string;
}
/**
 *
 * @export
 * @interface SolidityContractJsonArtifactGasEstimates
 */
export interface SolidityContractJsonArtifactGasEstimates {
    /**
     *
     * @type {SolidityContractJsonArtifactGasEstimatesCreation}
     * @memberof SolidityContractJsonArtifactGasEstimates
     */
    'creation'?: SolidityContractJsonArtifactGasEstimatesCreation;
    /**
     *
     * @type {{ [key: string]: any; }}
     * @memberof SolidityContractJsonArtifactGasEstimates
     */
    'external'?: {
        [key: string]: any;
    };
}
/**
 *
 * @export
 * @interface SolidityContractJsonArtifactGasEstimatesCreation
 */
export interface SolidityContractJsonArtifactGasEstimatesCreation {
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifactGasEstimatesCreation
     */
    'codeDepositCost'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifactGasEstimatesCreation
     */
    'executionCost'?: string;
    /**
     *
     * @type {string}
     * @memberof SolidityContractJsonArtifactGasEstimatesCreation
     */
    'totalCost'?: string;
}
/**
 * @type Web3SigningCredential
 * @export
 */
export type Web3SigningCredential = Web3SigningCredentialCactusKeychainRef | Web3SigningCredentialNone | Web3SigningCredentialPrivateKeyHex;
/**
 *
 * @export
 * @interface Web3SigningCredentialCactusKeychainRef
 */
export interface Web3SigningCredentialCactusKeychainRef {
    /**
     *
     * @type {Web3SigningCredentialType}
     * @memberof Web3SigningCredentialCactusKeychainRef
     */
    'type': Web3SigningCredentialType;
    /**
     * The ethereum account (public key) that the credential  belongs to. Basically the username in the traditional  terminology of authentication.
     * @type {string}
     * @memberof Web3SigningCredentialCactusKeychainRef
     */
    'ethAccount': string;
    /**
     * The key to use when looking up the the keychain entry holding the secret pointed to by the  keychainEntryKey parameter.
     * @type {string}
     * @memberof Web3SigningCredentialCactusKeychainRef
     */
    'keychainEntryKey': string;
    /**
     * The keychain ID to use when looking up the the keychain plugin instance that will be used to retrieve the secret pointed to by the keychainEntryKey parameter.
     * @type {string}
     * @memberof Web3SigningCredentialCactusKeychainRef
     */
    'keychainId': string;
}
/**
 * Using this denotes that there is no signing required because the transaction is pre-signed.
 * @export
 * @interface Web3SigningCredentialNone
 */
export interface Web3SigningCredentialNone {
    /**
     *
     * @type {Web3SigningCredentialType}
     * @memberof Web3SigningCredentialNone
     */
    'type': Web3SigningCredentialType;
}
/**
 *
 * @export
 * @interface Web3SigningCredentialPrivateKeyHex
 */
export interface Web3SigningCredentialPrivateKeyHex {
    /**
     *
     * @type {Web3SigningCredentialType}
     * @memberof Web3SigningCredentialPrivateKeyHex
     */
    'type': Web3SigningCredentialType;
    /**
     * The ethereum account (public key) that the credential belongs to. Basically the username in the traditional terminology of authentication.
     * @type {string}
     * @memberof Web3SigningCredentialPrivateKeyHex
     */
    'ethAccount': string;
    /**
     * The HEX encoded private key of an eth account.
     * @type {string}
     * @memberof Web3SigningCredentialPrivateKeyHex
     */
    'secret': string;
}
/**
 *
 * @export
 * @enum {string}
 */
export declare const Web3SigningCredentialType: {
    readonly CactusKeychainRef: "CACTUS_KEYCHAIN_REF";
    readonly GethKeychainPassword: "GETH_KEYCHAIN_PASSWORD";
    readonly PrivateKeyHex: "PRIVATE_KEY_HEX";
    readonly None: "NONE";
};
export type Web3SigningCredentialType = typeof Web3SigningCredentialType[keyof typeof Web3SigningCredentialType];
/**
 *
 * @export
 * @interface Web3TransactionReceipt
 */
export interface Web3TransactionReceipt {
    [key: string]: any;
    /**
     *
     * @type {boolean}
     * @memberof Web3TransactionReceipt
     */
    'status': boolean;
    /**
     *
     * @type {string}
     * @memberof Web3TransactionReceipt
     */
    'transactionHash': string;
    /**
     *
     * @type {number}
     * @memberof Web3TransactionReceipt
     */
    'transactionIndex': number;
    /**
     *
     * @type {string}
     * @memberof Web3TransactionReceipt
     */
    'blockHash': string;
    /**
     *
     * @type {number}
     * @memberof Web3TransactionReceipt
     */
    'blockNumber': number;
    /**
     *
     * @type {number}
     * @memberof Web3TransactionReceipt
     */
    'gasUsed': number;
    /**
     *
     * @type {string}
     * @memberof Web3TransactionReceipt
     */
    'contractAddress'?: string | null;
    /**
     *
     * @type {string}
     * @memberof Web3TransactionReceipt
     */
    'from': string;
    /**
     *
     * @type {string}
     * @memberof Web3TransactionReceipt
     */
    'to': string;
}
/**
 *
 * @export
 * @interface XdaiTransactionConfig
 */
export interface XdaiTransactionConfig {
    [key: string]: any;
    /**
     *
     * @type {string}
     * @memberof XdaiTransactionConfig
     */
    'rawTransaction'?: string;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof XdaiTransactionConfig
     */
    'from'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigTo}
     * @memberof XdaiTransactionConfig
     */
    'to'?: XdaiTransactionConfigTo;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof XdaiTransactionConfig
     */
    'value'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof XdaiTransactionConfig
     */
    'gas'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {XdaiTransactionConfigFrom}
     * @memberof XdaiTransactionConfig
     */
    'gasPrice'?: XdaiTransactionConfigFrom;
    /**
     *
     * @type {number}
     * @memberof XdaiTransactionConfig
     */
    'nonce'?: number;
    /**
     *
     * @type {XdaiTransactionConfigTo}
     * @memberof XdaiTransactionConfig
     */
    'data'?: XdaiTransactionConfigTo;
}
/**
 * @type XdaiTransactionConfigFrom
 * @export
 */
export type XdaiTransactionConfigFrom = number | string;
/**
 * @type XdaiTransactionConfigTo
 * @export
 */
export type XdaiTransactionConfigTo = string;
/**
 * DefaultApi - axios parameter creator
 * @export
 */
export declare const DefaultApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractJsonObjectV1Request} [deployContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractJsonObjectV1: (deployContractJsonObjectV1Request?: DeployContractJsonObjectV1Request, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractV1Request} [deployContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractV1: (deployContractV1Request?: DeployContractV1Request, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get the Prometheus Metrics
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getPrometheusMetricsV1: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Invokes a contract on a besu ledger
     * @param {InvokeContractJsonObjectV1Request} [invokeContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractJsonObject: (invokeContractJsonObjectV1Request?: InvokeContractJsonObjectV1Request, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Invokes a contract on a xdai ledger
     * @param {InvokeContractV1Request} [invokeContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractV1: (invokeContractV1Request?: InvokeContractV1Request, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Executes a transaction on a xdai ledger
     * @param {RunTransactionV1Request} [runTransactionV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    runTransactionV1: (runTransactionV1Request?: RunTransactionV1Request, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DefaultApi - functional programming interface
 * @export
 */
export declare const DefaultApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractJsonObjectV1Request} [deployContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractJsonObjectV1(deployContractJsonObjectV1Request?: DeployContractJsonObjectV1Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeployContractV1Response>>;
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractV1Request} [deployContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractV1(deployContractV1Request?: DeployContractV1Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeployContractV1Response>>;
    /**
     *
     * @summary Get the Prometheus Metrics
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getPrometheusMetricsV1(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Invokes a contract on a besu ledger
     * @param {InvokeContractJsonObjectV1Request} [invokeContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractJsonObject(invokeContractJsonObjectV1Request?: InvokeContractJsonObjectV1Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InvokeContractV1Response>>;
    /**
     *
     * @summary Invokes a contract on a xdai ledger
     * @param {InvokeContractV1Request} [invokeContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractV1(invokeContractV1Request?: InvokeContractV1Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InvokeContractV1Response>>;
    /**
     *
     * @summary Executes a transaction on a xdai ledger
     * @param {RunTransactionV1Request} [runTransactionV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    runTransactionV1(runTransactionV1Request?: RunTransactionV1Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RunTransactionV1Response>>;
};
/**
 * DefaultApi - factory interface
 * @export
 */
export declare const DefaultApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractJsonObjectV1Request} [deployContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractJsonObjectV1(deployContractJsonObjectV1Request?: DeployContractJsonObjectV1Request, options?: any): AxiosPromise<DeployContractV1Response>;
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractV1Request} [deployContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deployContractV1(deployContractV1Request?: DeployContractV1Request, options?: any): AxiosPromise<DeployContractV1Response>;
    /**
     *
     * @summary Get the Prometheus Metrics
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getPrometheusMetricsV1(options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Invokes a contract on a besu ledger
     * @param {InvokeContractJsonObjectV1Request} [invokeContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractJsonObject(invokeContractJsonObjectV1Request?: InvokeContractJsonObjectV1Request, options?: any): AxiosPromise<InvokeContractV1Response>;
    /**
     *
     * @summary Invokes a contract on a xdai ledger
     * @param {InvokeContractV1Request} [invokeContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    invokeContractV1(invokeContractV1Request?: InvokeContractV1Request, options?: any): AxiosPromise<InvokeContractV1Response>;
    /**
     *
     * @summary Executes a transaction on a xdai ledger
     * @param {RunTransactionV1Request} [runTransactionV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    runTransactionV1(runTransactionV1Request?: RunTransactionV1Request, options?: any): AxiosPromise<RunTransactionV1Response>;
};
/**
 * DefaultApi - object-oriented interface
 * @export
 * @class DefaultApi
 * @extends {BaseAPI}
 */
export declare class DefaultApi extends BaseAPI {
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractJsonObjectV1Request} [deployContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    deployContractJsonObjectV1(deployContractJsonObjectV1Request?: DeployContractJsonObjectV1Request, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DeployContractV1Response, any>>;
    /**
     *
     * @summary Deploys the bytecode of a Solidity contract.
     * @param {DeployContractV1Request} [deployContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    deployContractV1(deployContractV1Request?: DeployContractV1Request, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DeployContractV1Response, any>>;
    /**
     *
     * @summary Get the Prometheus Metrics
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    getPrometheusMetricsV1(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Invokes a contract on a besu ledger
     * @param {InvokeContractJsonObjectV1Request} [invokeContractJsonObjectV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    invokeContractJsonObject(invokeContractJsonObjectV1Request?: InvokeContractJsonObjectV1Request, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<InvokeContractV1Response, any>>;
    /**
     *
     * @summary Invokes a contract on a xdai ledger
     * @param {InvokeContractV1Request} [invokeContractV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    invokeContractV1(invokeContractV1Request?: InvokeContractV1Request, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<InvokeContractV1Response, any>>;
    /**
     *
     * @summary Executes a transaction on a xdai ledger
     * @param {RunTransactionV1Request} [runTransactionV1Request]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    runTransactionV1(runTransactionV1Request?: RunTransactionV1Request, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<RunTransactionV1Response, any>>;
}
