import { Express, Request, Response } from "express";
import { LogLevelDesc, IAsyncProvider } from "@hyperledger/cactus-common";
import { IEndpointAuthzOptions, IExpressRequestHandler, IWebServiceEndpoint } from "@hyperledger/cactus-core-api";
import { PluginLedgerConnectorXdai } from "../plugin-ledger-connector-xdai";
import OAS from "../../json/openapi.json";
export interface IInvokeContractJsonObjectEndpointOptions {
    logLevel?: LogLevelDesc;
    connector: PluginLedgerConnectorXdai;
}
export declare class InvokeContractJsonObjectEndpoint implements IWebServiceEndpoint {
    readonly options: IInvokeContractJsonObjectEndpointOptions;
    static readonly CLASS_NAME = "InvokeContractJsonObjectEndpoint";
    private readonly log;
    get className(): string;
    constructor(options: IInvokeContractJsonObjectEndpointOptions);
    get oasPath(): (typeof OAS.paths)["/api/v1/plugins/@hyperledger/cactus-plugin-ledger-connector-xdai/invoke-contract-json-object"];
    getPath(): string;
    getVerbLowerCase(): string;
    getOperationId(): string;
    getAuthorizationOptionsProvider(): IAsyncProvider<IEndpointAuthzOptions>;
    registerExpress(expressApp: Express): Promise<IWebServiceEndpoint>;
    getExpressRequestHandler(): IExpressRequestHandler;
    handleRequest(req: Request, res: Response): Promise<void>;
}
